unit Calc1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ParseExpr, Menus;
const
  Nundo = 41;
type
  TForm1 = class(TForm)
    ResultEdit: TEdit;
    Evaluate: TButton;
    Label2: TLabel;
    ExpressionEdit: TEdit;
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure EvaluateClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ExpressionEditChange(Sender: TObject);
  private
    { Private declarations }
    X, Y, Z: Double;
    PrevText: array[0..Nundo - 1] of string;
    Iprevtext: Integer;
    istartundo: Integer;
    MyParser: TExpressionParser;
    procedure AddToEdit(S: string);
    procedure UpdateUndo;
    procedure SetUndoText;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses Math;
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  MyParser := TCstyleParser.Create;
  TCStyleParser(MyParser).CStyle:=False;
  //For testing:
  //MyParser.DecimSeparator:=','; //ArgSeparator is changed automatically
  MyParser.DefineVariable('x', @X);
  MyParser.DefineVariable('y', @Y);
  MyParser.DefineVariable('z', @Z);
//  X := StrToFloat(XEdit.Text);
//  Y := StrToFloat(yEdit.Text);
//  Z := StrToFloat(ZEdit.Text);
//  FunctionsCombo.ItemIndex := 0;
  Iprevtext := -1;
  istartundo := -1;
//  FunctionsCombo.Clear;
//  FunctionsCombo.Items.add('()');
//  MyParser.GetFunctionNames(FunctionsCombo.Items);
//  PointButton.Caption := MyParser.DecimSeparator;
end;



procedure TForm1.EvaluateClick(Sender: TObject);
var
 I: Integer;
  procedure SetEditText(Edit: TEdit; X: Double);
  var
    OnCh: TNotifyEvent;
  begin
    OnCh := Edit.OnChange;
    Edit.OnChange := nil;
    Edit.Text := FloatToStr(X);
    Edit.OnChange := OnCh;
  end;
begin
//  MyParser.Optimize := OptimizeCheck.Checked;
  I := MyParser.AddExpression(ExpressionEdit.Text);
   ResultEdit.Text := MyParser.AsString[I];
//  NEvalLabel.Caption := IntToStr(MyParser.ExpressionSize[I]);
//  SetEditText(XEdit, X);
//  SetEditText(yEdit, Y);
//  SetEditText(ZEdit, Z);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I: Integer;
begin
  I := MyParser.AddExpression(ExpressionEdit.Text);
  ResultEdit.Text := MyParser.AsString[I];
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  MyParser.Free;
end;



procedure TForm1.UpdateUndo;
begin
  istartundo := -1;
  if (Iprevtext <= 0) or (PrevText[Iprevtext - 1] <> ExpressionEdit.Text) then
  begin
    Inc(Iprevtext);
    if Iprevtext >= Nundo then
      Iprevtext := 0;
    PrevText[Iprevtext] := ExpressionEdit.Text;
  end;
end;

procedure TForm1.AddToEdit(S: string);
var
  Len: Integer;
  IsFunction: Boolean;
begin
  if S = '' then S := ' ';
  with ExpressionEdit do
  begin
    IsFunction := Pos('(', S) > 0;
    Len := Sellength;
    if IsFunction and (Len > 0) then
    begin
      Sellength := 0;
      SelText := Copy(S, 1, Pos('(', S));
      SelStart := SelStart + Len;
      SelText := Copy(S, Pos('(', S) + 1, Len); ;
      SelStart := SelStart - 1;
    end
    else
    begin
      SelText := S;
      if IsFunction then SelStart := SelStart - 1;
    end;
  end;
end;




procedure TForm1.SetUndoText;
begin
  with ExpressionEdit do
  begin
    OnChange := nil;
    Text := PrevText[Iprevtext];
    SelStart := SelStart + Length(Text);
    Sellength := 0;
    OnChange := ExpressionEditChange;
  end;
end;



procedure TForm1.ExpressionEditChange(Sender: TObject);
begin
  UpdateUndo;
end;


end.

